# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free

Name:           apache-river
Version:        2.1.2
Release:        1%{?dist}
Epoch:          0
Summary:        Apache River Jini
License:        Apache Software License 2.0
Group:          Development/Libraries/Java
Url:            http://river.apache.org/
Source0:        apache-river-2.1.2.tgz
# svn export http://svn.apache.org/repos/asf/river/jtsk/tags/2.1.2 apache-river-2.1.2
# tar czf apache-river-2.1.2.tgz apache-river-2.1.2/

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-junit
BuildRequires:  cglib
BuildRequires:  junit4
BuildRequires:  mockito
BuildRequires:  multithreadedtc
BuildRequires:  objectweb-asm
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  objectweb-asm
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description
Apache River is a project furthering the development and 
advancement of Jini technology.
Jini is a service oriented architecture that defines a 
programming model which both exploits and extends Java 
technology to enable the construction of secure, 
distributed systems consisting of federations of services 
and clients. Jini technology can be used to build adaptive 
network systems that are scalable, evolvable and flexible 
as typically required in dynamic computing environments.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
mv test/lib/MultithreadedTC-1.01.jar test/lib/MultithreadedTC-1.01.jar.no
ln -s $(build-classpath multithreadedtc) test/lib/MultithreadedTC-1.01.jar
mv test/lib/junit-4.6.jar test/lib/junit-4.6.jar.no
ln -s $(build-classpath junit4) test/lib/junit-4.6.jar
mv test/lib/cglib-nodep-2.2.jar test/lib/cglib-nodep-2.2.jar.no
ln -s $(build-classpath cglib-nodep) test/lib/cglib-nodep-2.2.jar
mv test/lib/mockito-all-1.7.jar test/lib/mockito-all-1.7.jar.no
ln -s $(build-classpath mockito-all) test/lib/mockito-all-1.7.jar
mv lib/asm-commons-3.2.jar lib/asm-commons-3.2.jar.no
ln -s $(build-classpath objectweb-asm/asm-commons) lib/asm-commons-3.2.jar
mv lib/asm-3.2.jar lib/asm-3.2.jar.no
ln -s $(build-classpath objectweb-asm/asm) lib/asm-3.2.jar

%build
ant all.build doc

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/dl
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/ext

install -m 644 lib/browser.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/browser-%{version}.jar
install -m 644 lib/checkconfigurationfile.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/checkconfigurationfile-%{version}.jar
install -m 644 lib/checkser.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/checkser-%{version}.jar
install -m 644 lib/classdep.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/classdep-%{version}.jar
install -m 644 lib/classserver.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/classserver-%{version}.jar
install -m 644 lib/computedigest.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/computedigest-%{version}.jar
install -m 644 lib/computehttpmdcodebase.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/computehttpmdcodebase-%{version}.jar
install -m 644 lib/destroy.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/destroy-%{version}.jar
install -m 644 lib-dl/browser-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/browser-dl-%{version}.jar
install -m 644 lib-dl/fiddler-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/fiddler-dl-%{version}.jar
install -m 644 lib-dl/group-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/group-dl-%{version}.jar
install -m 644 lib-dl/jsk-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/jsk-dl-%{version}.jar
install -m 644 lib-dl/mahalo-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/mahalo-dl-%{version}.jar
install -m 644 lib-dl/mercury-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/mercury-dl-%{version}.jar
install -m 644 lib-dl/norm-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/norm-dl-%{version}.jar
install -m 644 lib-dl/outrigger-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/outrigger-dl-%{version}.jar
install -m 644 lib-dl/phoenix-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/phoenix-dl-%{version}.jar
install -m 644 lib-dl/reggie-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/reggie-dl-%{version}.jar
install -m 644 lib-dl/sdm-dl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dl/sdm-dl-%{version}.jar
install -m 644 lib/envcheck.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/envcheck-%{version}.jar
install -m 644 lib-ext/jsk-policy.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/ext/jsk-policy-%{version}.jar
install -m 644 lib/fiddler.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/fiddler-%{version}.jar
install -m 644 lib/group.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/group-%{version}.jar
install -m 644 lib/jarwrapper.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jarwrapper-%{version}.jar
install -m 644 lib/jini-core.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jini-core-%{version}.jar
install -m 644 lib/jini-ext.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jini-ext-%{version}.jar
install -m 644 lib/jsk-debug-policy.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jsk-debug-policy-%{version}.jar
install -m 644 lib/jsk-lib.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jsk-lib-%{version}.jar
install -m 644 lib/jsk-platform.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jsk-platform-%{version}.jar
install -m 644 lib/jsk-resources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jsk-resources-%{version}.jar
install -m 644 lib/mahalo.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/mahalo-%{version}.jar
install -m 644 lib/mercury.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/mercury-%{version}.jar
install -m 644 lib/norm.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/norm-%{version}.jar
install -m 644 lib/outrigger.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/outrigger-%{version}.jar
install -m 644 lib/outrigger-snaplogstore.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/outrigger-snaplogstore-%{version}.jar
install -m 644 lib/phoenix-group.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/phoenix-group-%{version}.jar
install -m 644 lib/phoenix-init.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/phoenix-init-%{version}.jar
install -m 644 lib/phoenix.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/phoenix-%{version}.jar
install -m 644 lib/preferredlistgen.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/preferredlistgen-%{version}.jar
install -m 644 lib/reggie.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/reggie-%{version}.jar
install -m 644 lib/serviceui.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/serviceui-%{version}.jar
install -m 644 lib/sharedvm.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/sharedvm-%{version}.jar
install -m 644 lib/start.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/start-%{version}.jar
install -m 644 lib/sun-util.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/sun-util-%{version}.jar
install -m 644 lib/tools.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tools-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/dl && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/ext && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# Install pom files
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 poms/jini-core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jini-core.pom
%add_to_maven_depmap net.jini jini-core %{version} JPP/%{name} jini-core
%add_to_maven_depmap org.apache.river jini-core %{version} JPP/%{name} jini-core
install -m 644 poms/jini-ext/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jini-ext.pom
%add_to_maven_depmap net.jini jini-ext %{version} JPP/%{name} jini-ext
%add_to_maven_depmap org.apache.river jini-ext %{version} JPP/%{name} jini-ext
install -m 644 poms/jsk-dl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsk-dl.pom
%add_to_maven_depmap org.apache.river jsk-dl %{version} JPP/%{name} jsk-dl
install -m 644 poms/jsk-lib/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsk-lib.pom
%add_to_maven_depmap org.apache.river jsk-lib %{version} JPP/%{name} jsk-lib
install -m 644 poms/jsk-platform/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsk-platform.pom
%add_to_maven_depmap org.apache.river jsk-platform %{version} JPP/%{name} jsk-platform
install -m 644 poms/jsk-policy/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsk-policy.pom
%add_to_maven_depmap org.apache.river jsk-policy %{version} JPP/%{name} jsk-policy
install -m 644 poms/jsk-resources/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsk-resources.pom
%add_to_maven_depmap org.apache.river jsk-resources %{version} JPP/%{name} jsk-resources
install -m 644 poms/services/fiddler/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-fiddler.pom
%add_to_maven_depmap org.apache.river fiddler %{version} JPP/%{name}/services fiddler
install -m 644 poms/services/mahalo/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-mahalo.pom
%add_to_maven_depmap org.apache.river mahalo %{version} JPP/%{name}/services mahalo
install -m 644 poms/services/mercury/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-mercury.pom
%add_to_maven_depmap org.apache.river mercury %{version} JPP/%{name}/services mercury
install -m 644 poms/services/norm/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-norm.pom
%add_to_maven_depmap org.apache.river norm %{version} JPP/%{name}/services norm
install -m 644 poms/services/outrigger/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-outrigger.pom
%add_to_maven_depmap org.apache.river outrigger %{version} JPP/%{name}/services outrigger
install -m 644 poms/services/outrigger-snaplogstore/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-outrigger-snaplogstore.pom
%add_to_maven_depmap org.apache.river outrigger-snaplogstore %{version} JPP/%{name}/services outrigger-snaplogstore
install -m 644 poms/services/phoenix-group/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-phoenix-group.pom
%add_to_maven_depmap org.apache.river phoenix-group %{version} JPP/%{name}/services phoenix-group
install -m 644 poms/services/phoenix/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-phoenix.pom
%add_to_maven_depmap org.apache.river phoenix %{version} JPP/%{name}/services phoenix
install -m 644 poms/services/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-phoenix.pom
%add_to_maven_depmap org.apache.river services %{version} JPP/%{name} services
install -m 644 poms/services/reggie/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.services-reggie.pom
%add_to_maven_depmap org.apache.river reggie %{version} JPP/%{name}/services reggie
install -m 644 poms/serviceui/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-serviceui.pom
%add_to_maven_depmap org.apache.river serviceui %{version} JPP/%{name} serviceui
install -m 644 poms/start/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-start.pom
%add_to_maven_depmap org.apache.river start %{version} JPP/%{name} start
install -m 644 poms/sun-util/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-sun-util.pom
%add_to_maven_depmap org.apache.river sun-util %{version} JPP/%{name} sun-util
install -m 644 poms/tools/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-tools.pom
%add_to_maven_depmap org.apache.river tools %{version} JPP/%{name} tools
install -m 644 poms/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.apache.river parent %{version} JPP/%{name} parent

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
install -m 644 examples/hello/lib/client.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
install -m 644 examples/hello/lib/mdprefld.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
install -m 644 examples/hello/lib/server-act.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
install -m 644 examples/hello/lib/server-dl.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
install -m 644 examples/hello/lib/server.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
ln -sf %{_javadir}/objectweb-asm/asm.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
ln -sf %{_javadir}/objectweb-asm/asm-commons.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/lib

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_javadir}/%{name}
%{_datadir}/%{name}
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/*

%changelog
* Sun Oct 02 2011 Ralph Apel <r.apel@r-apel.de> - 0:2.1.2-1
- first release

